# --------------------------------------------------------------------------------
# Documentation
# --------------------------------------------------------------------------------
# Add a make target 'doc' to generate API documentation with Doxygen. You should
# set options to your liking in the file 'Doxyfile.in'.
find_package(Doxygen)
if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile.in
                 ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(
    doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile &> doxygen.log
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT
      "${BoldMagenta}Generating API documentation with Doxygen (open ./html/index.html to view).${ColourReset}"
    VERBATIM)
endif(DOXYGEN_FOUND)
